Masahiro Yamada | 0a9064f | 2014-07-30 14:08:13 +0900 | [diff] [blame] | 1 | #!/bin/sh |
| 2 | # Check ncurses compatibility |
| 3 | |
| 4 | # What library to link |
| 5 | ldflags() |
| 6 | { |
| 7 | pkg-config --libs ncursesw 2>/dev/null && exit |
| 8 | pkg-config --libs ncurses 2>/dev/null && exit |
| 9 | for ext in so a dll.a dylib ; do |
| 10 | for lib in ncursesw ncurses curses ; do |
| 11 | $cc -print-file-name=lib${lib}.${ext} | grep -q / |
| 12 | if [ $? -eq 0 ]; then |
| 13 | echo "-l${lib}" |
| 14 | exit |
| 15 | fi |
| 16 | done |
| 17 | done |
| 18 | exit 1 |
| 19 | } |
| 20 | |
| 21 | # Where is ncurses.h? |
| 22 | ccflags() |
| 23 | { |
Masahiro Yamada | 9b5f0b1 | 2015-07-05 01:56:54 +0900 | [diff] [blame] | 24 | if pkg-config --cflags ncursesw 2>/dev/null; then |
| 25 | echo '-DCURSES_LOC="<ncurses.h>" -DNCURSES_WIDECHAR=1' |
| 26 | elif pkg-config --cflags ncurses 2>/dev/null; then |
| 27 | echo '-DCURSES_LOC="<ncurses.h>"' |
| 28 | elif [ -f /usr/include/ncursesw/curses.h ]; then |
Masahiro Yamada | 0a9064f | 2014-07-30 14:08:13 +0900 | [diff] [blame] | 29 | echo '-I/usr/include/ncursesw -DCURSES_LOC="<curses.h>"' |
| 30 | echo ' -DNCURSES_WIDECHAR=1' |
| 31 | elif [ -f /usr/include/ncurses/ncurses.h ]; then |
| 32 | echo '-I/usr/include/ncurses -DCURSES_LOC="<ncurses.h>"' |
| 33 | elif [ -f /usr/include/ncurses/curses.h ]; then |
| 34 | echo '-I/usr/include/ncurses -DCURSES_LOC="<curses.h>"' |
| 35 | elif [ -f /usr/include/ncurses.h ]; then |
| 36 | echo '-DCURSES_LOC="<ncurses.h>"' |
| 37 | else |
| 38 | echo '-DCURSES_LOC="<curses.h>"' |
| 39 | fi |
| 40 | } |
| 41 | |
| 42 | # Temp file, try to clean up after us |
| 43 | tmp=.lxdialog.tmp |
| 44 | trap "rm -f $tmp" 0 1 2 3 15 |
| 45 | |
| 46 | # Check if we can link to ncurses |
| 47 | check() { |
| 48 | $cc -x c - -o $tmp 2>/dev/null <<'EOF' |
| 49 | #include CURSES_LOC |
| 50 | main() {} |
| 51 | EOF |
| 52 | if [ $? != 0 ]; then |
| 53 | echo " *** Unable to find the ncurses libraries or the" 1>&2 |
| 54 | echo " *** required header files." 1>&2 |
| 55 | echo " *** 'make menuconfig' requires the ncurses libraries." 1>&2 |
| 56 | echo " *** " 1>&2 |
| 57 | echo " *** Install ncurses (ncurses-devel) and try again." 1>&2 |
| 58 | echo " *** " 1>&2 |
| 59 | exit 1 |
| 60 | fi |
| 61 | } |
| 62 | |
| 63 | usage() { |
| 64 | printf "Usage: $0 [-check compiler options|-ccflags|-ldflags compiler options]\n" |
| 65 | } |
| 66 | |
| 67 | if [ $# -eq 0 ]; then |
| 68 | usage |
| 69 | exit 1 |
| 70 | fi |
| 71 | |
| 72 | cc="" |
| 73 | case "$1" in |
| 74 | "-check") |
| 75 | shift |
| 76 | cc="$@" |
| 77 | check |
| 78 | ;; |
| 79 | "-ccflags") |
| 80 | ccflags |
| 81 | ;; |
| 82 | "-ldflags") |
| 83 | shift |
| 84 | cc="$@" |
| 85 | ldflags |
| 86 | ;; |
| 87 | "*") |
| 88 | usage |
| 89 | exit 1 |
| 90 | ;; |
| 91 | esac |